<?php

namespace Drupal\spotify_playing\Controller;

use Drupal\Core\Cache\CacheableJsonResponse;
use Drupal\Core\Cache\CacheableMetadata;
use Drupal\Core\Controller\ControllerBase;

/**
 * Processing and output for Spotify API data.
 */
class SpotifyController extends ControllerBase {

  const SETTINGS = 'spotify_playing.settings';

  /**
   * JSON Endpoint for Spotify Now Playing widgets.
   */
  public function content() {

    $api = \Drupal::service('spotify_playing.spotify_helper')->api();

    $data = [];

    if ($api) {
      $data['now'] = $api->getMyCurrentTrack() ?? [];
    }

    $data['#cache'] = [
      'max-age' => (1 * 5),
      'tags' => [
        'spotify_playing',
        'spotify_playing:now',
      ],
      'contexts' => [
        'url.path',
        'url.query_args',
      ],
    ];

    $response = new CacheableJsonResponse($data);

    $response->addCacheableDependency(CacheableMetadata::createFromRenderArray($data));

    return $response;

  }

}
